/**/

#include "rscommon.h"

int o_quiet= 0;
double max_mass=-1, max_volu=-1, max_capi=-1;
double distance_loss_factor_per_league;
int max_dist= -1;

#define CTR(x) int ctr_##x;
  COUNTER_LIST
#undef CTR

static PotentialResult ****results;
  /* results[start_isle_ix][finalisle][midisle]-> */

int main(int argc, const char **argv) {
  const char *arg;

#ifndef debug_flags
  debug_flags= ~( dbg_sql2 );
#endif
  sysassert( !setvbuf(debug,0,_IOLBF,0) );
  
  for (;;) {
    arg= *++argv;
    if (arg[0] != '-') break;
#ifndef debug_flags
    if (!strcmp(arg,"-DN")) {
      debug_flags= 0;
    } else
#endif
    {
      abort();
    }
  }

  max_mass= atof(*argv++);
  max_volu= atof(*argv++);
  max_capi= atof(*argv++);
  double loss_per_league= atof(*argv++);

  if (!loss_per_league) loss_per_league= 1e-7;
  distance_loss_factor_per_league= 1.0 - loss_per_league;

  setup_sql();
  setup_value();
  setup_search();

  fprintf(stderr,"setup complete, starting search\n");
  
  arg= *argv++;
  if (!strcmp(arg,"specific")) {
    int ia[argc], ni=0;
    while ((arg= *argv++))
      ia[ni++]= atoi(arg);

    double val= value_route(ni, ia, 0);
    printf("route value is %g\n", val);
  } else if (!strcmp(arg,"search")) {
    results= mcalloc(sizeof(*results)*argc);
    max_dist= atoi(*argv++);
    int resultsix= 0;
    while ((arg= *argv++)) {
      search(atoi(arg), &results[resultsix]);
      resultsix++;
    }

    int i, midarch, finarch;
    for (i=0; i<resultsix; i++) {
      fprintf(stderr,"================== start #%d ==================\n",i);
      PotentialResult ***strat_resultsix= results[i];
      if (!strat_resultsix) continue;
      fprintf(stderr,"  ");
      for (midarch=0; midarch<narches; midarch++) {
	fprintf(stderr,"| mid %d ",midarch);
      }
      fprintf(stderr,"\n");
      for (finarch=0; finarch<narches; finarch++) {
	PotentialResult **strat_finarch= strat_resultsix[finarch];
	if (!strat_finarch) continue;
	fprintf(stderr,"f%d",finarch);
	for (midarch=0; midarch<narches; midarch++) {
	  PotentialResult *result= strat_finarch[midarch];
	  if (!result) {
	    fprintf(stderr,"|       ");
	  } else {
	    if (result->absolute < 100) fprintf(stderr,"|  .");
	    else fprintf(stderr,"|%3d",(int)(result->absolute / 100));
	    fprintf(stderr," ");
	    if (result->perleague < 10) fprintf(stderr,"  .");
	    else fprintf(stderr,"%3d",(int)(result->perleague / 10));
	  }
	}
	fprintf(stderr,"\n");
      }
    }
  } else {
    abort();
  }

#define CTR(x) fprintf(stderr,"  %-30s %10d\n",#x,ctr_##x);
  COUNTER_LIST
#undef CTR

  return 0;
}
